%define plugin11 PeopsSoftGpu117
%define plugin12 PeopsSpu109
%define plugin13 cdr-1.8
%define plugin14 cdriso-1.4
%define plugin15 padXwin-1.6
%define plugin16 spu-1.6
%define plugin17 spunull-1.0
#%define plugin18 padJoy072
#%define plugin19 netSock-0.2
#%define plugin20 joypadXwin-1.1

Name: pcsx
Version: 1.5
Release: alt5

Summary: PlayStation emulator
License: GPL
Group: Emulators

Url: http://www.pcsx.net/
Packager: Gleb Stiblo <ulfr@altlinux.ru>

Source00: PcsxSrc-%version.tgz
Source01: Pcsx.32.xpm
Source02: Pcsx.48.xpm
Source03: Pcsx.16.xpm
Source04: Pcsx.menu
Source05: Pcsx-launch.sh
Source06: pcsx_i18n.h
Source07: pcsx-ru.po
Source11: %plugin11.tar.gz
Source12: %plugin12.tar.gz
Source13: %plugin13.tar.gz
Source14: %plugin14.tgz
Source15: %plugin15.tgz
Source16: %plugin16.tgz
Source17: %plugin17.tgz
#Source18: %plugin18.tgz
#Source19: %plugin19.tgz
#Source20: %plugin20.tgz

Patch01: pcsx-1.5-2.patch
Patch02: pcsx-gcc.patch
Patch11: Pcsx-%plugin11-2.patch
Patch12: Pcsx-%plugin12-2.patch
Patch13: Pcsx-%plugin13-2.patch
Patch14: Pcsx-%plugin14-2.patch
Patch15: Pcsx-%plugin15-2.patch
Patch16: Pcsx-%plugin16-2.patch
Patch17: Pcsx-%plugin17.patch
Patch22: Pcsx-%plugin12.config.patch
Patch23: Pcsx-padXwin-1.6-ld.patch
Patch24: Pcsx-PeopsSoftGpu117-gcc.patch
Patch25: pcsx-gcc4_cfg.patch


BuildRequires: XFree86-devel XFree86-libs gcc libgtk+2-devel pkgconfig zlib-devel nasm bzlib-devel
Provides: Pcsx
Obsoletes: Pcsx

%description
Pcsx is a PSX emulator. What that really means? It means that it emulates the
way that a PSX works and tries to translate PSX machine language to PC language.
That is very hard to be done and we can't speak for 100% success in any time.
The hardware would always be better than the software so if you wanna play games
then better get a real PSX. Pcsx is capable to run most of the games, but a few
others still don't.

%prep
%setup -c -q 
%patch01 -p0
%patch02 -p1
%__mkdir %plugin11; %__tar xzf %SOURCE11 -C %plugin11
%__mkdir %plugin12; %__tar xzf %SOURCE12 -C %plugin12
%__tar xzf %plugin12/src/linuxcfg/spucfg.tar.gz -C %plugin12/src/linuxcfg
%__mkdir %plugin13; %__tar xzf %SOURCE13 -C %plugin13
%__mkdir %plugin14; %__tar xzf %SOURCE14 -C %plugin14
%__mkdir %plugin15; %__tar xzf %SOURCE15 -C %plugin15
%__mkdir %plugin16; %__tar xzf %SOURCE16 -C %plugin16
%__mkdir %plugin17; %__tar xzf %SOURCE17 -C %plugin17
#__mkdir %plugin18; %__tar xzf #SOURCE18 -C %plugin18
#__mkdir %plugin19; %__tar xzf #SOURCE19 -C %plugin19
#__mkdir %plugin20; %__tar xzf #SOURCE20 -C %plugin20

%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%__subst "s/\r//g" PeopsSpu109/src/linuxcfg/configure.in
%__subst "s/\r//g" PeopsSpu109/src/linuxcfg/autogen.sh
%__subst "s/\r//g" PeopsSpu109/src/linuxcfg/src/Makefile.am
pushd PeopsSpu109/src/
#%patch22 -p0
popd

echo -e "\n">> PeopsSoftGpu117/src/gpu.h
echo -e "\n">> PeopsSoftGpu117/src/menu.h
echo -e "\n">> PeopsSoftGpu117/src/prim.h
echo -e "\n">> PeopsSoftGpu117/src/psemu.h
echo -e "\n">> PeopsSpu109/src/dsoundoss.h
echo -e "\n">> PeopsSpu109/src/regs.h
echo -e "\n">> PeopsSpu109/src/record.h
echo -e "\n">> PeopsSpu109/src/reverb.h
echo -e "\n">> PeopsSpu109/src/reverb.c
echo -e "\n">> PeopsSpu109/src/adsr.c
echo -e "\n">> PeopsSpu109/src/xa.c
echo -e "\n">> PeopsSpu109/src/xa.h
echo -e "\n">> padXwin-1.6/src/PSEmu\ Plugin\ Defs.h 
echo -e "\n">> spu-1.6/src/PSEmu\ Plugin\ Defs.h 
echo -e "\n">> spunull-1.0/src/PSEmu\ Plugin\ Defs.h 

%__cp %SOURCE6 ./
%__ln_s $(pwd)/pcsx_i18n.h %plugin11/src/
%__ln_s $(pwd)/pcsx_i18n.h %plugin12/src/
%__ln_s $(pwd)/pcsx_i18n.h %plugin12/src/linuxcfg
%__ln_s $(pwd)/pcsx_i18n.h %plugin13/src/
%__ln_s $(pwd)/pcsx_i18n.h %plugin13/src/cfg-gtk2
%__ln_s $(pwd)/pcsx_i18n.h %plugin14/cdriso/src/
%__ln_s $(pwd)/pcsx_i18n.h %plugin14/cdriso/src/Linux
%__ln_s $(pwd)/pcsx_i18n.h %plugin15/src/
%__ln_s $(pwd)/pcsx_i18n.h %plugin16/src/
%__ln_s $(pwd)/pcsx_i18n.h %plugin17/src/

%patch23 -p1
%patch24 -p1
%patch25 -p1

%build

#building plugins
#make_build -C %plugin18/padJoy/src
#make_build -C %plugin19/netSock/Src/Linux
#make_build -C %plugin20/joystick

%make_build -C %plugin11/src
%make_build -C %plugin12/src
#FIXME:pushd PeopsSpu109/src/linuxcfg; ./autogen.sh; popd
#FIXME:%make_build -C %plugin12/src/linuxcfg
%make_build -C %plugin13/src
%make_build -C %plugin14/cdriso/src/Linux
%make_build -C %plugin15/src 
%make_build -C %plugin16/src
%make_build -C %plugin17/src

#building emulator
cd PcsxSrc-%version/Linux
unset CC CXX
aclocal
autoconf
export CFLAGS="$CFLAGS -g"
%configure
%make_build


%install
#__mkdir_p %buildroot%_iconsdir
%__install -pD -m644 %SOURCE1 %buildroot%_iconsdir/pcsx.xpm
#__mkdir_p %buildroot%_liconsdir
%__install -pD -m644 %SOURCE2 %buildroot%_liconsdir/pcsx.xpm
#__mkdir_p %buildroot%_miconsdir
%__install -pD -m644 %SOURCE3 %buildroot%_miconsdir/pcsx.xpm

%__install -pD -m644 %SOURCE4 %buildroot%_menudir/pcsx

%__install -pD -m755 %SOURCE5 %buildroot%_bindir/pcsx
%__install -pD -m755 PcsxSrc-%version/Linux/pcsx %buildroot%_bindir/pcsx.bin
%__mkdir_p %buildroot%_libdir/pcsx/

%__install -pD -m755 %plugin11/src/libgpuPeopsSoftX.so.1.0.17 %buildroot%_libdir/pcsx/libgpuPeopsSoftX.so.1.0.17
%__install -pD -m755 %plugin11/src/cfgPeopsSoft %buildroot%_bindir/cfgPeopsSoft

%__install -pD -m755 %plugin12/src/libspuPeopsOSS.so.1.0.9 %buildroot%_libdir/pcsx/libspuPeopsOSS.so.1.0.9
#FIXME:%__install -pD -m755 %plugin12/src/linuxcfg/src/spucfg %buildroot%_bindir/cfgPeopsOSS

%__install -pD -m755 %plugin13/src/libcdr-1.8.so %buildroot%_libdir/pcsx/libcdr-1.8.so
%__install -pD -m755 %plugin13/src/cfg-gtk2/cfgCdr %buildroot%_bindir/cfgCdr

%__install -pD -m755 %plugin14/cdriso/src/Linux/libcdriso-1.4.so %buildroot%_libdir/pcsx/libcdriso-1.4.so
%__install -pD -m755 %plugin14/cdriso/src/Linux/cfgCdrIso %buildroot%_bindir/cfgCdrIso

%__install -pD -m755 %plugin15/src/libpadXwin-1.6.so %buildroot%_libdir/pcsx/libpadXwin-1.6.so
%__install -pD -m755 %plugin15/src/cfgPadXwin %buildroot%_bindir/cfgPadXwin

%__install -pD -m755 %plugin16/src/libspu-1.6.so %buildroot%_libdir/pcsx/libspu-1.6.so

%__install -pD -m755 %plugin17/src/libspunull-1.0.so %buildroot%_libdir/pcsx/libspunull-1.0.so

#__install -pD -m755 %plugin18/padJoy/src/libpadJoy-0.7.so %buildroot%_libdir/pcsx/libpadJoy-0.7.so

#__install -pD -m755 %plugin19/netSock/Src/Linux/libnetSock-0.2.so %buildroot%_libdir/pcsx/libnetSock-0.2.so
#__install -pD -m755 %plugin19/netSock/Src/Linux/cfgNetSock %buildroot%_bindir/cfgNetSock

#__install -pD -m755 %plugin20/joystick/libjoypadXwin-1.1.so %buildroot%_libdir/pcsx/libjoypadXwin-1.1.so

%__mkdir_p doc/%plugin11
%__cp %plugin11/*.txt %plugin11/src/*.txt doc/%plugin11
%__chmod -R 644 doc/%plugin11/*

%__mkdir_p doc/%plugin12
%__cp %plugin12/*.txt %plugin12/src/*.txt doc/%plugin12
%__chmod -R 644 doc/%plugin12/*

%__mkdir_p doc/%plugin13
%__cp %plugin13/*.{txt,cfg} doc/%plugin13

%__mkdir_p doc/%plugin14
%__cp %plugin14/cdriso/*.txt doc/%plugin14

%__mkdir_p doc/%plugin15
%__cp %plugin15/*.txt doc/%plugin15

%__mkdir_p doc/%plugin16
%__cp %plugin16/*.txt doc/%plugin16

%__mkdir_p doc/%plugin17
%__cp %plugin17/*.txt doc/%plugin17

#__mkdir_p doc/%plugin18
#__cp %plugin18/padJoy/*.txt doc/%plugin18

#__mkdir_p doc/%plugin19
#__cp %plugin19/netSock/*.txt doc/%plugin19

#__mkdir_p doc/%plugin20
#__cp %plugin20/joystick/*.txt doc/%plugin20

%__mkdir_p %buildroot%_datadir/pixmaps/pcsx/
%__install -pD -m644 PcsxSrc-%version/Linux/.pixmaps/* %buildroot%_datadir/pixmaps/pcsx/

%__mkdir_p %buildroot/usr/share/locale/ru/LC_MESSAGES/
msgfmt -o %buildroot/usr/share/locale/ru/LC_MESSAGES/pcsx.mo %SOURCE7
%find_lang pcsx


%post
%update_menus

%postun
%clean_menus

%files
%doc PcsxSrc-%version/Docs/* doc/%plugin11 doc/%plugin12 doc/%plugin13 doc/%plugin14 doc/%plugin15 doc/%plugin16 doc/%plugin17
%_bindir/*
%_menudir/*
%_iconsdir/pcsx.xpm
%_liconsdir/pcsx.xpm
%_miconsdir/pcsx.xpm
#%_libdir/pcsx/*
%_datadir/pixmaps/pcsx/*
%_libdir/pcsx
%_datadir/locale/ru/LC_MESSAGES/pcsx.mo

%changelog
* Tue Jan 16 2007 Gleb Stiblo <ulfr@altlinux.ru> 1.5-alt5
- cfgPeopsOSS temporary removed

* Mon Jan 15 2007 Gleb Stiblo <ulfr@altlinux.ru> 1.5-alt4
- fix gcc4 build
- renamed to pcsx

* Mon Dec 06 2004 Gleb Stiblo <ulfr@altlinux.ru> 1.5-alt3
- /usr/lib/pcsx added

* Mon May 03 2004 Gleb Stiblo <ulfr@altlinux.ru> 1.5-alt2
- glibc 2.3 build

* Fri Mar 05 2004 Gleb Stiblo <ulfr@altlinux.ru> 1.5-alt1
- ALT adaptation


